require_relative 'hyde'

server = Hyde::Server.new Port: 8000 do
  root "/home/yessiest/Projects/hyde/test/"
  serve "index.html"
  index ["index.html"]
  path "about" do
    preprocess do |ctx|
      puts "#{ctx} entered fully virtual directory!"
    end
    postprocess do |ctx|
      puts "#{ctx} reached endpoint!"
    end
    finalize do |ctx|
      puts "#{ctx} finished processing!"
    end
    get "portal" do |ctx|
      ctx.vars[:ass] = true
      rewrite "/about/hyde"
    end
    get "webrick" do |ctx|
      ctx.response.body = "WEBrick is a modular http server stack"
      ctx.response['Content-Type'] = "text/plain"
    end
    get "en_passant" do |ctx|
      puts "holy hell!"
      redirect "https://google.com/search?q=en+passant"
    end
    get "hyde" do |ctx|
      puts ctx.vars[:ass]
      ctx.response.body = "Hyde is the disgusting side of Jekyll, and, by extension, the thing that makes WEBrick usable."
      ctx.response['Content-Type'] = "text/plain"
    end
    post "hyde" do |ctx|
      ctx.response.body = "Your message: #{ctx.request.body}"
      ctx.response['Content-Type'] = "text/plain"
    end
  end
  path "uploads" do
    index ["index.html"]
    serve "**/*.md", safe_regexp: false
    serve ["*.html","**/*.html"], safe_regexp: false
  end
end

server.start
